"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  useEventListener: () => useEventListener
});
module.exports = __toCommonJS(src_exports);
var import_react = require("react");
var useEventListener = (eventType, callback, { target = globalThis, ...options } = {}) => {
  const savedCallback = (0, import_react.useRef)(callback);
  (0, import_react.useEffect)(() => {
    savedCallback.current = callback;
  }, [callback]);
  (0, import_react.useEffect)(() => {
    const targetElement = "current" in target ? target.current : target;
    if (!(targetElement == null ? void 0 : targetElement.addEventListener))
      return;
    const handler = (ev) => savedCallback.current(ev);
    targetElement.addEventListener(eventType, handler, options);
    return () => {
      targetElement.removeEventListener(eventType, handler, options);
    };
  }, [target, eventType, options]);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useEventListener
});
