// src/index.ts
import { useEffect, useRef } from "react";
var useEventListener = (eventType, callback, { target = globalThis, ...options } = {}) => {
  const savedCallback = useRef(callback);
  useEffect(() => {
    savedCallback.current = callback;
  }, [callback]);
  useEffect(() => {
    const targetElement = "current" in target ? target.current : target;
    if (!(targetElement == null ? void 0 : targetElement.addEventListener))
      return;
    const handler = (ev) => savedCallback.current(ev);
    targetElement.addEventListener(eventType, handler, options);
    return () => {
      targetElement.removeEventListener(eventType, handler, options);
    };
  }, [target, eventType, options]);
};
export {
  useEventListener
};
